/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package fr.unicaen.openmap.gui;

import fr.unicaen.openmap.layer.thematicDataDisplayLayer.visu.Thematic;
import fr.unicaen.openmap.util.Util;
import java.awt.Color;
import java.awt.event.ItemEvent;
import java.awt.event.ItemListener;
import javax.swing.ImageIcon;
import javax.swing.JButton;
import javax.swing.JCheckBox;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JToggleButton;

/**
 *
 * @author jchauvea
 */
public  class ThematicTreeNodeComponent extends ThemaMapTreeNodeComponent {


    protected Thematic thematic;


    public ThematicTreeNodeComponent(LayersTree tree, Thematic thematic) {
        this.thematic = thematic;
        this.tree = tree;
        setBackground(Color.WHITE);
        add(getOnOffButton());
        add(new JLabel(getTVImageIcon()));
        //System.out.println("------------------------------------------------------------------------------");
        //System.out.println("//////////////////////////////////////////////////////////"+thematic.getName());
        try{
        String tvName = thematic.getName();
        lab = new JLabel(tvName);
        add(lab);
       // System.out.println(thematic.getClass() + ": "+tvName);
       // System.out.println("------------------------------------------------------------------------------");
        }catch(Exception e){e.printStackTrace();}       
        repaint();
    }

    private ImageIcon getTVImageIcon() {
        return Util.loadIcon("visu/" + Util.className(thematic) + ".png");
    }

    protected JToggleButton getOnOffButton() {
        JCheckBox b = new JCheckBox(
                thematic.isVisible() ? Util.loadIcon("enabled.png") : Util.loadIcon("disabled.png"), thematic.isVisible());
        //JCheckBox b = new JCheckBox();
        b.setBorder(/*BorderFactory.createEmptyBorder(0,0,0,10)*/null);
        b.setBorderPainted(false);
        b.setFocusPainted(false);
        b.setBackground(Color.WHITE);
        b.setOpaque(false);
        b.setFocusable(true);
        b.addItemListener(new ItemListener() {

            public void itemStateChanged(ItemEvent e) {
                if (ThematicTreeNodeComponent.this.getBackground() != Color.LIGHT_GRAY) {
                    ThematicTreeNodeComponent.this.setBackground(Color.LIGHT_GRAY);
                }
                JCheckBox bsource = (JCheckBox) e.getSource();
                if (e.getStateChange() == ItemEvent.SELECTED) {
                    bsource.setIcon(Util.loadIcon("enabled.png"));
                    thematic.setVisible(true);
                } else {
                    bsource.setIcon(Util.loadIcon("disabled.png"));
                    thematic.setVisible(false);
                }
                thematic.getLayer().refreshGraphicsAndGUI();
            }
        });
        return b;
    }
}
