/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package fr.unicaen.openmap.layer.chartLayer.chart;

import fr.unicaen.openmap.dataStorage.DataObject;
import fr.unicaen.openmap.dataStorage.DataStorageIterator;
import fr.unicaen.openmap.layer.thematicDataDisplayLayer.util.ColorScale;
import java.awt.image.BufferedImage;
import javax.swing.JComponent;
import org.jfree.chart.ChartFactory;
import org.jfree.chart.ChartPanel;
import org.jfree.chart.JFreeChart;
import org.jfree.chart.plot.PlotOrientation;
import org.jfree.data.category.DefaultCategoryDataset;

/**
 *
 * @author jchauvea
 */
public class BarChart extends Chart{

    private DefaultCategoryDataset dataset;

    public BarChart(DataStorageIterator dsi, String name, String xName, String yName, String[] categories, String[] series){
        super(dsi, name, xName, yName, categories, series);
    }

    @Override
    protected void buildDataSet(DataStorageIterator dsi) {
        dataset = new DefaultCategoryDataset();
        dsi.reset();
        while(dsi.hasNext()){
            DataObject dataObj = dsi.next();
//            String type = (String)dataObj.getData(serieColumn);
//            for(String s : typeColunms){
//                Double d = Double.parseDouble(dataObj.getData(s).toString());
//                dataset.setValue(d, type, s);
//            }
        }

    }

    @Override
    public BufferedImage getImage(int w, int h) {
        JFreeChart chart = ChartFactory.createBarChart(name, xName, yName, dataset,
                PlotOrientation.VERTICAL, true, true, true);
        return chart.createBufferedImage(w, h);
    }

    @Override
    public JFreeChart getJFreeChart() {
        return ChartFactory.createBarChart(name, xName, yName, dataset,
                PlotOrientation.VERTICAL, true, true, true);
    }

}
