// <header>
/**
 *  Themamap: The Thematic Maps Production Tool
 *
 *  Copyright (c) 2008 Université de Caen Basse-Normandie, Certic
 *  Copyright (c) 2008 Université de Caen Basse-Normandie, GREYC
 *                     		
 *  This program is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *  <http://www.gnu.org/licenses/>
 *
 *  See http://themamap.info.unicaen.fr/authors/
 *      for a list of contributors 
 */
// </header>
package fr.unicaen.openmap.dataStorage.postgis.db;

import fr.unicaen.openmap.dataStorage.DataObject;

import com.bbn.openmap.omGraphics.*;

import java.util.Vector;

/**
 * Store data and geometry.
 */
public class DBTableRow extends Vector<DataObject> {
    
    /**
     *
     */
    private DataObject dataObject = null;
    
    /**
     */
    // private OMGraphic omGraphic = null;
    
    /**
     * Construct object.
     */
    public DBTableRow() { }
    
    /**
     * Add an OMGraphic to the row. 
     */
    /*
    public void addOMGraphic(OMGraphic omg) {
	omGraphic=omg;
    }
    */
    public void addDataObject(DataObject dataObject) {
	this.dataObject = dataObject;
    }
    
    public DataObject getDataObject() {
	return dataObject;
    }
    
    /**
     * Return the OMGraphic associated to the row.
     * @return Could be null.
     */
    /*
    public OMGraphic getOMGraphic() { 
	return omGraphic;
    }
    */
    

    /*
     * @return True if the omg is in this row, false otherwise.
     */
    /*
    public boolean contains(OMGraphic omg) { 
	return omGraphic==omg;
    }
    */
    /*    public boolean contains(OMDataObject omdl) {
	return this.omdl == omdl;
    }
    */
    
}
