/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package fr.unicaen.openmap.layer.thematicDataDisplayLayer.omGraphics;

import com.bbn.openmap.omGraphics.OMPoint;
import com.bbn.openmap.proj.coords.LatLonPoint;
import java.awt.Color;
import java.awt.event.MouseEvent;

/**
 *Control point of OMOffsetable
 * @author dje
 */
public class OMOffsetableControlPoint extends OMPoint implements ThemaMapControlPoint{

    private OMOffsetable offsetable;
    public OMOffsetableControlPoint(LatLonPoint llpt, OMOffsetable omf,int xOff, int yOff) {
        super(llpt.getLatitude(), llpt.getLongitude(),xOff, yOff);
        setFillPaint(Color.YELLOW);
        setSelectPaint(Color.RED);
        this.offsetable = omf;
        setSelected(false);

    }

    public void doActionPressed(MouseEvent e) {
        offsetable.startDrag();
    }

    public void doActionReleased(MouseEvent e) {
        offsetable.endDrag();
    }

    public void doActionDragged(MouseEvent e) {
        offsetable.updatePosition(e.getX(), e.getY());


    }

//    public void select() {
//        super.select();
//    }

    @Override
    public void setSelected(boolean bool) {
        setFillPaint(bool ? Color.RED : Color.YELLOW);
        super.setSelected(bool);
    }

}
