/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package fr.unicaen.openmap.layer.utils;

import com.bbn.openmap.Layer;
import com.bbn.openmap.LayerHandler;
import fr.unicaen.openmap.AtlasLayerHandler;
import java.io.IOException;
import java.net.URL;

/**
 *
 * @author jchauvea
 */
public class AtlasLayerLoader extends LayerLoader {

    public AtlasLayerLoader(URL url, AtlasLayerHandler layerHandler) {
        super(url, layerHandler);
    }

    @Override
    public Layer initLayer(String layerName) {
        String classProperty = layerName + ".class";
        //System.out.println("INIT -> " + classProperty);
        String className = properties.getProperty(classProperty);
        Object obj;
        try {
            obj = java.beans.Beans.instantiate(null, className);
            if (obj instanceof Layer) {
                Layer l = (Layer) obj;
                //l.setProperties(layerName, properties);
                l.setName(layerName);
                ((AtlasLayerHandler)layerHandler).addLoadableLayer(l, layerName, properties);
                return l;
            }
        } catch (IOException e) {
            e.printStackTrace();
        } catch (ClassNotFoundException e) {
            e.printStackTrace();
        }
        return null;
    }
}
